document.body.style.width = `${window.innerWidth}px`;
document.body.style.height = `${window.innerHeight}px`;
const {
  ControlPanelItemFeatures,
  StorageManagerInstance,
  isSupportedWebComponent,
  clientTool,
  getVersion
} = JCCGuestPlugin;

const app = Vue.createApp({
  data() {
    return {
      ControlPanelItemFeatures: ControlPanelItemFeatures,
      showGuestComponent: false,

      showPreDetect: false,
      
      showToast: false,
      showToastList: [],
      callTypeList: [{label: '点对点呼叫', value: 'oneToOne'}, {label: '组号呼叫', value: 'group'}],
      authTypeList: [{label: 'REDIS(token可不填)', value: 'redis'}, {label: 'AUTH', value: 'auth'}, {label: 'STATIC_TOKEN', value: 'staticToken'}],
      requireSettings: {
        address: 'https://videobu.juphoon.cloud:10047',
        appKey: '05c97ce0d0a84d2592334093',
        token: '',
        authType: 'redis',
      },
      config: {
        call: {
        },
        component: {
          controlPanel: {
            excludeFeatureList: [],
          }
        },
      },
      versionData: null,
    };
  },
  created() {
    this.versionData = getVersion();
    this.reset();
    const settingFormData = StorageManagerInstance.get('settingFormData');
    if (settingFormData) {
      Object.entries(settingFormData)
        .forEach((entity) => this[entity[0]] = entity[1]);
    }

    window.addEventListener('beforeunload', (ev) => {
      const {requireSettings, config} = this;

      StorageManagerInstance.set('settingFormData', {
        requireSettings,
        config
      });

      ev.preventDefault();
      ev.returnValue = '';
      return '';
    });
  },
  unmounted() {
  },
  methods: {
    call() {
      if (!isSupportedWebComponent()) {
        alert('当前浏览器不支持使用web插件, 请更换浏览器');
      } else {
        this.showGuestComponent = true;
        this.$nextTick(() => {
          this.$refs['guest-component'].call();
        });
        // clientTool.authMediaDevice()
        //   .then(() => {
        //     this.showGuestComponent = true;
        //     this.$nextTick(() => {
        //       this.$refs['guest-component'].call();
        //     });
        //   })
        //   .catch((reason) => {
        //     alert(reason.message);
        //   })
      }
    },
    detect() {
      this.showPreDetect = true;
    },
    reset() {
      this.address = 'https://videobu.juphoon.cloud:10047';
      this.appKey = '05c97ce0d0a84d2592334093';
      this.token = '';
      this.authType = 'redis';
      this.config = {
        call: {
          callType: 'group',
          telNumber: '10086',
          agentUserId: '',
          auto: true
        },
        component: {
          controlPanel: {
            excludeFeatureList: [],
          }
        },
      };
    },
    callStateChange(ev) {
      const {callState} = ev.detail;

      switch (callState) {
        case 'termed':
          this.showGuestComponent = false;
          break;
      }
    },
    authStateChange(ev) {
      const {auth, message} = ev.detail;

      if (!auth) {
        console.log(message);
        this.showGuestComponent = false;
      }
    },
    handleError(ev) {
      const {error} = ev.detail;

      switch (error) {
        case 'clientLoadingFailCancel':
          this.showGuestComponent = false;
          break;
      }
    },
    detectDone() {
      this.showPreDetect = false;
    }
  }
})
  .mount('#app');
